/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/system_wide.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
typedef enum { 
   ok, /* successful completion of the routine */
   out_of_range,
   divide_by_zero,
   overflow,
   undefined_extremum,
   conversion_error,
   insufficient_space,
   semantic_error,
   string_overflow,
   bad_interval 
} error_type;

/*
* Error environment variable  REMOVED
extern jmp_buf global_error_env;
*/

typedef enum { FALSE, TRUE} bool;

/*
* used to pass strings parameters
*/

typedef struct string_struct_type{
        int length;
        int capacity;
        char *string;
} *string_struct;

/* 
*  Routine:  internal_error
*
*  Description: Call this routine if a non-recoverable error occurs.  It
*               executes a longjump, a graceful transfer of control to the
*               error handler and constructs an error message.  A carriage
*               return is automatically appended to the message.
*
*  Arguments:   varargs -- (IN) : error message format and text, expected 
*                                 call looks just like an sprintf, e.g.,
*                                    internal_error("%s %d", "hello", 23);
*  Return Value: none
*
*  Errors: none
* 
*  Side Effects: Control passes to previous setjmp
*/
void internal_error();

/*
*  Routine:  error_handler
*
*  Description: Handle non-recoverable states.  Currently just print a
*               message and die gracefully.  Must be called once prior
*               to use of internal_error.
*
*  Arguments:   none
*
*  Return Value: none
*
*  Errors: none
*
*  Side Effects: Terminates program
*/
void error_handler();

