/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/newh/ucs/global.h
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#ifndef ucs_global
#define ucs_global

#include "cs.h"
/* ucs_global.h
*
* This file includes declarations for ucs global variables.  The variables
*  is this header file are all external globals.  The declarations are in
*  the file ucs_init.c
*
*/

/* externally defined variables */
extern calendric_system_type calendric_system_list[];
extern unsigned char ucs_cal_number;
extern int NumCalendars;
extern int NumberOfCS;
extern int gen_fv_max_field_functions;
extern int gen_fv_max_field_tables;
extern int ucs_max_formal_args;
extern calendric_system_type *active_local_cs;
extern calendric_system_type *active_global_cs;
extern char *gen_function_names_alias_names[];
extern char *gen_function_names_mapped_names[];

/* global ucs values */
extern seconds_type ucs_secs1;
extern event_type ucs_e1;
extern span_type ucs_span1;
extern span_type ucs_span2;
extern string_struct ucs_str1;
extern string_struct ucs_str2;

#endif
