/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/tadt/test/builtin_test.c
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
/* Test code for the tadt comparison routines */
#include <stdio.h>
#include "system_wide.h"
#include "tadt_int.h"
#include "tadt_ext.h"
#include "tadt_memory.h"
#include "tadt_comparison.h"
#define MAXEV 11

void main()
{
  /*
  interval_type inhihi1, inhihi2,
		inhilow1in3, in4;
  event_type evhi1, evhi2, evhi3, evhi4, evhio;
  event_type evlow1, evlow2, evlow3, evlow4, evlowo;
  event_type evex1, evex2, evex3, evex4, evexo;
  event_type evsp1, evsp2, evsp3;
  span_type fs1, fs2, fs3, fs4;
  */
  event_type ev[special][MAXEV];
  int one, two, i, j;
  static void init_hires_e(), init_lowres_e(), init_exres_e(), dump_ev();
  void printf();

  for (i=0; i<MAXEV; i++) for (j=0; j<MAXEV; j++) {
    ev[i][j] = tadt_allocate_e(i);
    }

  /* Events to test (one of each resolution) */
  /*                         e9 */
  /*                      e8    */
  /*                   e7       */
  /*                e6          */
  /*            origin          */
  /*          e4                */
  /*       e3                   */
  /*    e2                      */
  /* e1                         */

  init_hires_e(ev[hi][0], 0x0, 0x0000000, 0x000,   0,   0);
  init_hires_e(ev[hi][1], 0x0, 0x0000000, 0x000,   0,   1);
  init_hires_e(ev[hi][2], 0x0, 0x0000000, 0x000,   1,   0);
  init_hires_e(ev[hi][3], 0x0, 0x0000000, 0x001,   0,   0);
  init_hires_e(ev[hi][4], 0x0, 0x0000001, 0x000,   0,   0);
  init_hires_e(ev[hi][5], 0x1, 0x0000000, 0x000,   0,   0);
  init_hires_e(ev[hi][6], 0x1, 0x0000001, 0x000,   0,   0);
  init_hires_e(ev[hi][7], 0x1, 0x0000001, 0x001,   0,   0);
  init_hires_e(ev[hi][8], 0x1, 0x0000001, 0x001,   1,   0);
  init_hires_e(ev[hi][9], 0x1, 0x0000001, 0x001,   1,   1);
  init_hires_e(ev[hi][10], 0x1, 0x0000001, 0x002,   1,   1);

  init_lowres_e(ev[low][0], 0x0, 0x0000000, 0x000);
  init_lowres_e(ev[low][1], 0x0, 0x0000000, 0x001);
  init_lowres_e(ev[low][2], 0x0, 0x0000000, 0x002);
  init_lowres_e(ev[low][3], 0x0, 0x0000000, 0x003);
  init_lowres_e(ev[low][4], 0x0, 0x0000001, 0x000);
  init_lowres_e(ev[low][5], 0x1, 0x0000000, 0x000);
  init_lowres_e(ev[low][6], 0x1, 0x0000001, 0x000);
  init_lowres_e(ev[low][7], 0x1, 0x0000001, 0x001);
  init_lowres_e(ev[low][8], 0x1, 0x0000001, 0x002);
  init_lowres_e(ev[low][9], 0x1, 0x0000001, 0x003);
  init_lowres_e(ev[low][10], 0x1, 0x0000001, 0x004);

  init_exres_e(ev[extended][0], 0x0, 0x0000000, 0x000,   0,   0, 1);
  init_exres_e(ev[extended][1], 0x0, 0x0000000, 0x000,   0,   1, 0);
  init_exres_e(ev[extended][2], 0x0, 0x0000000, 0x000,   1,   0, 0);
  init_exres_e(ev[extended][3], 0x0, 0x0000000, 0x001,   0,   0, 0);
  init_exres_e(ev[extended][4], 0x0, 0x0000001, 0x000,   0,   0, 0);
  init_exres_e(ev[extended][5], 0x1, 0x0000000, 0x000,   0,   0, 0);
  init_exres_e(ev[extended][6], 0x1, 0x0000001, 0x000,   0,   0, 0);
  init_exres_e(ev[extended][7], 0x1, 0x0000001, 0x001,   0,   0, 0);
  init_exres_e(ev[extended][8], 0x1, 0x0000001, 0x001,   1,   0, 0);
  init_exres_e(ev[extended][9], 0x1, 0x0000001, 0x001,   1,   1, 0);
  init_exres_e(ev[extended][10], 0x1, 0x0000001, 0x001,   1,   1, 1);

  for (one=0; one<special; one++) for (two=one; two<special; two++) {
  printf("one %d two %d\n",one,two);
  for (i=0; i<MAXEV; i++) for (j=0; j<MAXEV; j++) {
      if (i < j) {
        if (!tadt_e_precedes_e(ev[one][i],ev[two][j])) {
	  printf("NO: %d %d %d %d\n", one, two, i, j);
	  dump_ev(ev[one][i]);
	  dump_ev(ev[two][j]);
	  }
	}
      else
        if (tadt_e_precedes_e(ev[one][i],ev[two][j])) {
	  printf("YES: %d %d %d %d\n", one, two, i, j);
	  dump_ev(ev[one][i]);
	  dump_ev(ev[two][j]);
	  }
      }
    }

}

static void init_hires_e(event_type ev, unsigned int sign, unsigned int shi, 
	     unsigned int slow, unsigned int milli, unsigned int micro)
{
  ev->hires.sign = sign;
  ev->hires.secondshi = shi;
  ev->hires.secondslow = slow;
  ev->hires.milli = milli;
  ev->hires.micro = micro;
}

static void init_exres_e(event_type ev, unsigned int sign, unsigned int shi, 
	     unsigned int slow, unsigned int milli, 
	     unsigned int micro, unsigned int nano)
{
  ev->exres.sign = sign;
  ev->exres.secondshi = shi;
  ev->exres.secondslow = slow;
  ev->exres.milli= milli;
  ev->exres.micro = micro;
  ev->exres.nano = nano;
}

static void init_lowres_e(event_type ev, unsigned int sign, unsigned int shi, 
	     unsigned int slow)
{
  ev->lowres.sign = sign;
  ev->lowres.secondshi = shi;
  ev->lowres.secondslow = slow;
}

static void dump_ev(event_type ev)
{
  unsigned int temphi, templow;

  switch (ev->generic.ts_type) {
    case hi:
       temphi = ev->hires.secondshi >> 20;
       templow = ev->hires.secondshi & 0x000FFFFF;
       templow = ev->hires.secondshi << 12;
       templow = templow ^ ev->hires.secondslow;
       printf(" %x %10x %10x %5d %5d     0\n", ev->hires.sign,
	 temphi, templow, ev->hires.milli,
	 ev->hires.micro);
       break;
    case low:
       printf(" %x %10x %10x     0     0     0\n", ev->lowres.sign,
	 ev->lowres.secondshi, ev->lowres.secondslow);
       break;
    case extended:
       printf(" %x %10x %10x %5d %5d %5d\n", ev->exres.sign,
	 ev->exres.secondshi, ev->exres.secondslow, ev->exres.milli,
	 ev->exres.micro, ev->exres.nano);
       break;
    default: printf(" jusnk\n"); break;
    }
}
