/***********************************************************************\ 
*                                                                       * 
*   File: calendric_system/tadt/test/moving.c
*                                                                       * 
*   The MultiCal System is free software in the public domain; you can  * 
*   redistribute it and/or modify it as you wish. We ask that you       * 
*   retain credits referencing the University of Arizona and that you   * 
*   identify any changes you make.                                      * 
*                                                                       * 
*   Report problems to multical@cs.arizona.edu                          * 
*   Direct all inquiries to:    The MultiCal Project                    * 
*                               Department of Computer Science          * 
*                               University of Arizona                   * 
*                               Tucson, AZ 85721                        * 
*                               U.S.A.                                  * 
*                                                                       * 
\***********************************************************************/ 
#include <stdio.h>
#include <sys/time.h>
#include "system_wide.h"
#include "tadt.h"

/*
#define TESTING
*/

#ifdef TESTING
static int numoftrials = 1; /*300*/;
#else
static int numoftrials = 100; /*300*/;
#endif

int main() {
  event_type ev1, ev2;
  int i, j, k;
  bool before(), eval;
  void printf(), gettimeofday();
  struct timeval tp1, tp2;
  int temp1, temp2;

  eval = TRUE;
  error_handler();
  tadt_init();

  ev1 = tadt_allocate_e(upack);
  ev1->upack_ind.indeterminate = 1;
  ev1->upack_ind.lower.seconds = 1;
  ev1->upack_ind.upper.seconds = 2000000;
  ev1->upack_ind.distribution.name = UNIFORM;

  ev2 = tadt_allocate_e(upack);
  ev2->upack_ind.indeterminate = 1;
  ev2->upack_ind.lower.seconds = 6000001;
  ev2->upack_ind.upper.seconds = 8000000;
  ev2->upack_ind.distribution.name = UNIFORM;

  for (k=0;k<50;k++) {

    for (i=1;i<=100;i++) {

      gettimeofday(&tp1,NULL);

      for (j=0; j<numoftrials; j++) eval = tadti_e_precedes_e(i, ev1, ev2);

      gettimeofday(&tp2,NULL);

      temp1 = tp1.tv_sec * 1000000 + tp1.tv_usec;
      temp2 = tp2.tv_sec * 1000000 + tp2.tv_usec;
      temp1 = temp2 - temp1;

#ifdef TESTING
      if (eval) printf("TRUE %d %d ", k, i);
      else printf("False %d %d ", k, i);
#endif
      printf("%d\n", (temp1/numoftrials));

      }

    printf("\n");
    ev1->upack_ind.lower.seconds += 250000;
    ev1->upack_ind.upper.seconds += 250000;

    }
  return TRUE;
}
